<?lsp
local fmt=string.format
local function toLi(names,uris)
   local tinsert=table.insert
   local isfirst=true
   local t={}
   for k,v in ipairs(uris) do
      if type(v) == 'string' then
         tinsert(t, fmt("<li%s><a href='%s'>%s</a></li>",
                        isfirst and " class='first'" or "",
                        v,
                        names[k]))
      else
         tinsert(t,fmt("<li%s><span>",isfirst and " class='first'" or ""))
         tinsert(t,names[k])
         tinsert(t,"</span><ul>")
         tinsert(t,toLi(v.nt,v.ut,t))
         tinsert(t,"</ul></li>")          
      end
      isfirst=false
   end
   return table.concat(t)
end

local function emitLinks()
   if page.names ~= app.links.names then -- If links updated
      page.names = app.links.names
      page.links=toLi(app.links.names, app.links.uris) 
   end
   print(page.links)
end

local function toHref(name,uri)
   return fmt("<a href='%s'>%s</a>\n",uri,name)
end

local function emitBlogLinks()
   if app.cats then
      if page.cats ~= app.cats then -- If categories updated
         page.cats = app.cats
         local t={}
         local uris=app.cats.uris
         for k,v in ipairs(app.cats.names) do
            table.insert(t, toHref(v, uris[k]))
         end
         page.catlinks=fmt("<div class='archives' id='archives'><h3 class='negative'>Categories</h3><pre>%s</pre></div>",table.concat(t))
      end
      print(page.catlinks)
   end
   print("<div class='archives' id='archives'><h3 class='negative'>Archives</h3><pre>")
   if page.archList ~= app.archList then -- If archive list updated
      page.archList = app.archList
      local t={}
      local month=cmsMonth
      for _,year in ipairs(app.archList) do
         local y = year.y
         table.insert(t,toHref(fmt("<b class='negative'>%s</b>",y),"/blog/"..y))
         for _,m in ipairs(year.m) do
            table.insert(t,toHref(month(m),fmt("/blog/%s/%s",y,m)))
         end
      end
      page.arch=table.concat(t)
   end
   write(page.arch,"</pre></div>")
   
end

local function emitContent()
   if cmsBlog then
      local permalink,id,date,cat,subj,name,data=cmsBlog()
      while permalink do
         local pi = cmsPostedIn(cat)
         write("<h1 id='blogh'><a href='",
                        permalink,
                        "'>",
                        subj,
                        "</a></h1>",
                        data,
                        "<p>",
                        pi and pi or "",
                        os.date(" %A, %B %dth, %Y ", date),
                        #name > 0 and (" by "..name) or "",
                        "</p>")
         local title,fbKey=cmsFbComments()
         if title then
            if fbKey then
               write'<a name="fbcomments"></a>'
               app.emitFbCommentBox(write,id,fbKey)
            else
               write("<p><a href='",permalink,"#fbcomments'>",title,"</a></p>")
            end
         end
         permalink,id,date,cat,subj,name,data=cmsBlog()
      end
   else
      cmsEmitPage()
   end
end

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:fb="http://www.facebook.com/2008/fbml">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title><?lsp=cmsTitle?></title>
<link href="/theme/default.css" rel="stylesheet" type="text/css" />
<?lsp=cmsHeader?>
<script src="/theme/default.js" type="text/javascript"></script>
</head>
<body style="background: #E5E5E5;">
<div id="page">
<div><img src="/theme/images/dheader.jpg" alt="" width="980" /></div>
<div id="sidebar">
<?lsp if cmsShowAdmLinks then ?>
<div id="login">
<b>Edit:</b>
<div style="padding-left:3em"><div id="cmsManage"></div></div></div>
<?lsp end ?>
<div id="menu"><ul><?lsp emitLinks() ?></ul></div>
<?lsp 
if cmsIsBlog then
   emitBlogLinks()
elseif cmsShowLogin then
if cmsUname then
?>
<div id="login">
<p>You are logged in as <?lsp=cmsUname?>.</p>
<p><a href="/rtl/protected/wfslinks.lsp">Access My Files</a><br />
<p><a href="/rtl/protected/">Change Password</a><br />
</div>
<?lsp else ?>
<div id="login">
<h2 class="title1">Registered Users</h2>
<fieldset>
<label for="inputtext1">Username:</label>
<input id="inputtext1" type="text" name="i1" value="" />
<label for="inputtext2">Password:</label>
<input id="inputtext2" type="password" name="i2" value="" />
<input id="inputsubmit1" type="submit" value="Sign In" onclick="login('inputtext1','inputtext2');"/>
</fieldset>
</div>
<?lsp
end
end
if emitColumn then emitColumn() end
?>
</div>
<!-- end sidebar -->
<div id="content">
<div class="boxed">
<?lsp emitContent() ?>
</div>
</div>
<!-- end content -->
<div style="clear: both;">&nbsp;</div>
</div>
<!-- end page -->
<div id="footer">
<p id="bdinfo">
FuguHub includes: 
<a target="rtl" href="http://FuguHub.com/MxTunnel.lsp">Secure Remote Access</a>,
<a target="rtl" href="http://realtimelogic.com/products/barracuda-web-server/">Web Server</a>,
<a target="rtl" href="http://FuguHub.com/BulletinBoard.lsp">Bulletin Board</a>,
<a target="rtl" href="http://FuguHub.com/cms.lsp">Content Management System</a>,
<a target="rtl" href="http://FuguHub.com/blog.lsp">Blog Engine</a>,
<br/>
<a target="rtl" href="http://FuguHub.com/database.lsp">SQLite Database</a>,
<a target="rtl" href="http://FuguHub.com/FileServer.lsp">WebDAV Server</a>, and more.
</p>
<p id="links">
<br/>
<?lsp
if cmsRssUri then
  write("<a href='",cmsRssUri,"' title='Feed URL'><img src='/images/feedIcon.png' alt='RSS feed' style='margin:0 1em 0 1em;border:none;float:left'/></a>")
end
?>
</p>
</div>
<?lsp cmsEmitGA() ?>
</body>
</html>
