<?lsp

local fmt=string.format 

local headercontent
if not page.red or cmsIsAdmin then
   local f = app.cmsdocs.open("red.txt", "rb")
   if f then
      page.red=f:read"*a"
      headercontent=page.red
      f:close();
   elseif cmsIsAdmin then
      headercontent="Create red.txt"
   else
      headercontent=""
   end
else
   headercontent=page.red
end


local function toHref(name,uri)
   return fmt("<a href='%s'>%s</a>\n",uri,name)
end


local function emitBlogLinks()
   if app.cats then
      write("<h2>Categories</h2><ul>",app.cats.li(),"</ul>")
   end
   print("<h2>Archives</h2><ul><li>")
   if page.archList ~= app.archList then -- If archive list updated
      page.archList = app.archList
      local t={}
      local month=cmsMonth
      for _,year in ipairs(app.archList) do
         local y = year.y
         table.insert(t,toHref(fmt("<b>%s</b>",y),"/blog/"..y))
         for _,m in ipairs(year.m) do
            table.insert(t,toHref(month(m),fmt("/blog/%s/%s",y,m)))
         end
      end
      page.arch=table.concat(t,"</li><li>")
   end
   write(page.arch,"</ul>")
end

local function emitContent()
   if cmsBlog then
      local permalink,id,date,cat,subj,name,data=cmsBlog()
      while permalink do
         local pi = cmsPostedIn(cat)
         write("<h1><a href='",
                        permalink,
                        "'>",
                        subj,
                        "</a></h1><p>",
                        os.date(" %A, %B %dth, %Y ", date),
                        #name > 0 and (" by "..name) or "",
                        "</p>",
                        data,
                        "<p>",
                        pi and pi or "",
                        "</p>")
         local title,fbKey=cmsFbComments()
         if title then
            if fbKey then
               write'<a name="fbcomments"></a>'
               app.emitFbCommentBox(write,id,fbKey)
            else
               write("<p><a href='",permalink,"#fbcomments'>",title,"</a></p>")
            end
         end
         write"<hr class='bloge'/>"
         permalink,id,date,cat,subj,name,data=cmsBlog()
      end
   else
      cmsEmitPage()
   end
end
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:fb="http://www.facebook.com/2008/fbml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title><?lsp=cmsTitle?></title>
<link href="/theme/red.css" rel="stylesheet" type="text/css" />
<?lsp=cmsHeader?>
</head>
<body>
<div id="header">
<?lsp
if cmsRssUri then
   write("<a id='feedurl' href='",cmsRssUri,"' title='Feed URL'><img src='/images/feedIcon.png' alt='RSS feed' style='border:none'/></a>")
end
?>
<div id="logo"><h1><?lsp=headercontent?></h1></div>
<ul id="topmenu">
<?lsp

local moreLinks
local subLinkName
local subLinks
do
   local uriN=0
   local curURI=request:uri()
   local names=app.links.names
   for k,v in ipairs(app.links.uris) do
      local url
      local found
      if type(v) == "string" then
         url=v
      else
         url=v.ut[1]
         if not subLinkName then
            for _,u in pairs(v.ut) do
               if curURI == u then
                  found=true
                  break
               end
            end
            if found then
               subLinkName=names[k]
               subLinks={}
               local n=v.nt
               for k,v in pairs(v.ut) do
                  -- Stop at sub menu level 2
                  if type(v) == "string" then
                     table.insert(subLinks,fmt("<a href='%s'>%s</a>",v,n[k]))
                  end
               end
            end
         end
      end
      if url then
         local lnk=fmt("<a href='%s'>%s</a>",url,names[k])
         if uriN > 4 then
            if not moreLinks then moreLinks = {} end
            table.insert(moreLinks,lnk)
         else
            if found or url == curURI then
               write("<li class='current'>",lnk,"</li>")
            else
               write("<li>",lnk,"</li>")
            end
         end
         uriN = uriN + 1
      end
   end
end
?>
</ul>
</div>
<div id="contents"><?lsp emitContent() ?></div>
<?lsp
if subLinks then
   write("<ul id='menu'><li>",table.concat(subLinks, "</li><li>"),"</li></ul>")
elseif moreLinks then
   write("<ul id='menu'><li>",table.concat(moreLinks, "</li><li>"),"</li></ul>")
end
if cmsIsBlog then
   pfmt("<div id='blgmenu' style='top:%spx'>", moreLinks and "300" or "160")
   emitBlogLinks()
   print"</div>"
end
?>
<div id="footer">
<?lsp
if cmsIsAdmin then
   print"<a href='/private/manage/' title='Configure Application'>Configure</a>"
   if cmsShowAdmLinks then
      print"<div id='cmsManage'></div>"
   end
else
   print'Powered by the <a target="rtl" href="http://realtimelogic.com/products/barracuda-application-server/">Barracuda Application Server</a> and the <a target="rtl" href="http://realtimelogic.com/products/sharkssl/">SharkSSL Embedded SSL Stack</a>'
end
?>
</div>
<?lsp cmsEmitGA() ?>
</body>
</html>
