<?lsp
if not bd.passwdRecovery() then
   response:sendredirect"/"
   return
end

local emailfmt=[[

Hello %s,

You or someone else requested your password.
The request originated from a computer with IP address: %s

Your password is: %s

We encourage you to change your password as soon as possible.

]]

local isPost
if request:method()=="POST" then
   isPost=true
   local email=request:data"email"
   if email then
      email=email:gsub("^%s*(.-)%s*$", "%1")
      local db=bd.db.load("emails", true).v
      if db then
         local edb={}
         for n,e in pairs(db) do
            edb[e] = n
         end
         local name=edb[email]
         if name then
            local userdb = bd.db.user.load()
            if userdb and userdb.v and userdb.v[name] then
               local user = userdb.v[name]
               if user then
                  local peer=request:peername()
                  local function sendMail()
                     local m={
                        subject="Your Password",
                        body=string.format(emailfmt, name, peer, user.pwd),
                        to=email
                     }
                     local ok, e = bd.sendmail(m) 
                     if not ok then
                        trace("Recovering password for user",name, " failed: ",e)
                     end
                  end
                  ba.thread.run(sendMail)
               end
            end
         end
      end
   end
end

?>
<?lsp
-- The extra header we need ".header" to add.
headerdata=[[
<style>
p {text-align:center}
input.wide { width:250px; }
#theform {width:370px;margin-top:30px;margin-left: auto ;margin-right: auto ;background:#F0F0F0;padding:6px;border: 2px ridge;border-radius: 10px;box-shadow: 10px 10px 5px #888;}
</style>
<script type="text/javascript" src="../jquery.js"></script>
]]


title="Recover Password"
response:include"/rtl/.header.lsp"
if isPost then
?>
<h1>Email Sent</h1>
<p>An email with your password has been dispatched if the provided email address was found in our database.</p>

<?lsp else ?>
<h1>Forgot your Password?</h1>

<p>Enter your registered Email Address below and we will email you the password.</p>

<form id="theform" method="post">
<table style="text-align: right;">
<tr>
<td>Email Address: </td><td><input class="wide" type="text" name="email"/></td>
</tr>
<tr>
<td colspan="2"><input type="submit" value="Send Password" /></td>
</tr>
</table>
</form>

<?lsp 
end
response:include"/rtl/.footer.lsp"
?>
