<?lsp

local fmt=string.format

function save(pageKey,data,lsp,cache,compress)
   if lsp then
      lsp=1;
      if cache then
         lsp=2;
      end
      if compress then
         lsp = 0x10 + lsp;
      end
   else
      lsp=0
   end
   local host = request:header"host"
   if host then
      -- In the editor, some browsers create an absolute link URL for images.
      host = fmt("(https?://%s)",host:gsub("([%[%^%$%(%)%%%.%[%]%*%+%-%?])",
                                           function(x) return "%"..x end))
      data = data:gsub(host, function() return "" end)
   end
   local na,e=conn:execute(fmt(
      [[UPDATE links SET date=%u,data='%s',lsp='%u' WHERE k=%s]],
      os.time(),
      data:gsub("'","''"),
      lsp,
      pageKey))
   if e then error(e) end
   app.emptyPageCache()
   return  "ok"
end

function load(pageKey,checkIfLsp)
   local cur,e=conn:execute(fmt(
      [[SELECT DISTINCT data,lsp FROM links WHERE k=%s]],
      pageKey))
   if e then error(e) end
   local data=""
   local lspType=0
   if cur then
      data,lspType = cur:fetch()
      lspType=tonumber(lspType)
      cur:close()
   end
   local lsp = lspType % 0x10
   if checkIfLsp then
      return lsp > 0 and true or false
   end
   local compEnabled = lsp ~= lspType and true or false
   return {
      data = data,
      lsp = (lsp > 0 and true or false),
      cache = (lsp > 1 and true or false),
      compress = compEnabled
   }
end


local service = jsonrpc.new("Editor",
                               {
                                  editor={
                                     save=save,
                                     load=load,
                                  }
                               })
response:reset()
collectgarbage()
collectgarbage()
env,conn = app.openDb()
service:execute(request, response)
app.closeDb(env,conn)
request:session().cmsIsAdmin=true
?>
