<?lsp

local rss=app.getRssSettings()
local fmt=string.format
local env,conn = app.openDb()

local data = request:method() == "POST" and bd.xssfilter(bd.trim(request:data())) or {}

if data.title then
   local enabled = data.enabled and "true" or "false"
   data.enabled = nil
   local ttl = tonumber(data.ttl)
   if not ttl then
      ttl=240
   elseif ttl < 20 then
      ttl=20
   end
   data.ttl=tostring(ttl)
   local maxlen = tonumber(data.maxlen)
   if not maxlen then
      maxlen=500
   elseif maxlen < 100 and maxlen ~= 0 then
      maxlen=100
   end
   data.maxlen=tostring(maxlen)
   local entries = tonumber(data.entries)
   if not entries or entries < 1 then
      entries=1
   end
   data.entries=tostring(entries)
   local sqlT={}
   for k,v in pairs(data) do
      table.insert(sqlT, fmt("UPDATE rss SET value='%s' WHERE key='%s';",v:gsub("'","''"),k))
   end
   table.insert(sqlT, fmt("UPDATE rss SET value='%s' WHERE key='enabled';",enabled))
   local ok,resp,err=conn:mexec(table.concat(sqlT))
   if ok then
      app.rss = enabled and data or nil -- Cache in app table. Used by blog engine
      app.categoriesUpdated()
      rss=app.getRssSettings()
   else
      trace(resp,err)
   end
elseif data.rowid then
   rowid=data.rowid
   local description = #data.description > 0 and data.description or rss.description
   local ttl = tonumber(data.ttl)
   ttl = tonumber(ttl) and ttl > 20 and data.ttl or rss.ttl
   local maxlen = tonumber(data.maxlen)
   maxlen = tonumber(maxlen) and maxlen > 100 and data.maxlen or rss.maxlen
   local image = #data.image > 0 and data.image or rss.image
   conn:execute(fmt(
      [[UPDATE blogcategories SET description='%s',ttl='%s',maxlen='%s',image='%s' WHERE ROWID=%s]],
      description:gsub("'","''"),
      ttl,
      maxlen,
      image:gsub("'","''"),
      rowid))
   app.emptyPageCache()
end

-- The extra header we need ".header" to add.
headerdata=[[
<script type="text/javascript" src="/rtl/eh/eh.js"></script>
<script type="text/javascript" src="/rtl/json/json.js"></script> 
<script type="text/javascript" src="/rtl/json/jrpc.js"></script>
<script type="text/javascript" src="categories.js"></script>
<script type="text/javascript" src="rss.js"></script>
]]
title="CMS: RSS Feeds"
response:include".header.lsp"


?>
<script type="text/javascript">
function setSelCatRowid() {
<?lsp if rowid then response:write("selCatRowid=",rowid,";"); end ?>
};
</script>
<div id="help"></div>

<h1>Configure RSS Blog Feeds</h1>

<div style="margin-left:auto; margin-right:auto;width:600px;">
<fieldset style="background: #F0EFE6;"><legend><b>&nbsp;Main Blog RSS Feed Settings&nbsp;</b></legend>
<div style='float:right'>
<a href='http://en.wikipedia.org/wiki/RSS_(file_format)' title='What is RSS?' target='_blank'><img hlp='intro' src='btn/questionmark.32.gif' alt='RSS feed' style='margin:1em;border:none'/></a>
<?lsp if rss.enabled == 'true' then print("<br/><a href='/blog/blog.rss' title='Feed URL'><img src='/images/feedIcon.png' alt='RSS feed' style='margin:1em;border:none'/></a>") end ?>
</div>

<form method="post">
<table cellpadding="5" style="width:500px">
  <tr>
    <td>Blog Title:</td>
    <td style="width:100%"><input type="text" id="title" name="title" style="width:100%" value="<?lsp=rss.title?>"/></td>
    <td><img hlp='BlogTitle' src='btn/questionmark.16.gif' alt='help'/></td>
  </tr>
  <tr>
    <td>Description:</td>
    <td><textarea id="MainDescr" name="description" rows="2" style="width:100%"><?lsp=rss.description?></textarea></td>
    <td><img hlp='Description' src='btn/questionmark.16.gif' alt='help'/></td>
  </tr>
  <tr>
    <td>Time To Live:</td>
    <td><input type="text" name="ttl" style="width:100%" value="<?lsp=rss.ttl?>"/></td>
    <td><img hlp='TTL' src='btn/questionmark.16.gif' alt='help'/></td>
  </tr>
  <tr>
    <td>Max Characters:</td>
    <td><input type="text" name="maxlen" style="width:100%" value="<?lsp=rss.maxlen?>"/></td>
    <td><img hlp='MaxCharacters' src='btn/questionmark.16.gif' alt='help'/></td>
  </tr>
  <tr>
    <td>Entries:</td>
    <td><input type="text" name="entries" style="width:100%" value="<?lsp=rss.entries?>"/></td>
    <td><img hlp='Entries' src='btn/questionmark.16.gif' alt='help'/></td>
  </tr>
  <tr>
    <td>Copyright:</td>
    <td><input type="text" name="copyright" style="width:100%" value="<?lsp=rss.copyright?>"/></td>
    <td><img hlp='Copyright' src='btn/questionmark.16.gif' alt='help'/></td>
  </tr>
  <tr>
    <td>Image Path:<br/><input type="button" value="Browse" onclick="browseImg('mainUrl');" /></td>
    <td><input type="text" name="image" style="width:100%" id="mainUrl" value="<?lsp=rss.image?>"/></td>
    <td><img hlp='ImagePath' src='btn/questionmark.16.gif' alt='help'/></td>
  </tr>
  <tr>
    <td>Enable/Disable RSS:</td>
    <td><input type='checkbox' id="EnableRSS" name='enabled' <?lsp=rss.enabled=="true" and "checked" or""?>/></td>
    <td></td>
  </tr>
</table>
<input type="submit" value="Save" />
</form>
</fieldset>
</div>
<br/>
<br/>
<?lsp if app.rss then ?>
<div id="catdiv" style="margin-left:auto; margin-right:auto;width:600px;display:none">
  <table style="width:100%"><tr>
  <td>
    <b>Categories:</b>
    <select id="category">
      <option value="0">No Category</option>
    </select>
  </td>
  <td>
  <input type="submit" value="Edit Categories" onclick="openCategoryEditor();return false;"/>
  </td>
  </tr></table>
  <br/>
  <fieldset style="background: #F0EFE6;"><legend><b id="catlegend"></b></legend>
<div style='float:right'>
<img hlp='Category' src='btn/questionmark.32.gif' alt='RSS feed' style='margin:1em;border:none'/><br/>
<a id='CatFeedUrl' href='' title='Feed URL'><img src='/images/feedIcon.png' alt='RSS feed' style='margin:1em;border:none'/></a>
</div>
<form method="post">
<table cellpadding="5" style="width:500px">
  <tr>
    <td>Description:</td>
    <td style="width:100%"><textarea id="description" name="description" rows="2" style="width:100%"></textarea></td>
  </tr>
  <tr>
    <td>Time To Live:</td>
    <td><input type="text" id="ttl" name="ttl" style="width:100%" value=""/></td>
  </tr>
  <tr>
    <td>Max Characters:</td>
    <td><input type="text" id="maxlen" name="maxlen" style="width:100%" value=""/></td>
  </tr>
  <tr>
    <td>Image Path:<br/><input type="button" value="Browse" onclick="browseImg('image');" /></td>
    <td><input type="text" id="image" name="image" style="width:100%" value=""/></td>
  </tr>
</table>
<br/>
<input type="hidden" id="rowid" name="rowid" value=""/>
<input type="submit" value="Save" />
</form>
</fieldset>
</div>
<br/>
<?lsp end ?>
</body>
</html>
<?lsp 
app.closeDb(env,conn)
response:include".footer.lsp"
?>
