<?lsp

local data = request:data()
local cfg = bd.cfg.load()
local davtmo = math.floor(cfg.v.davtmo/60) -- secs -> mins
if data.timeout then
   local t = tonumber(data.timeout)
   if t ~= nil then
      if t == 0 or t >= 10 then
         cfg.v.davtmo = t * 60 -- Convert to seconds
         bd.cfg.save(cfg)
         davtmo=t
      end
   end
end

-- The extra header we need ".header" to add.
headerdata=[[
<link href="style.css" rel="stylesheet" type="text/css" />
<link href="appmgr/style.css" rel="stylesheet" type="text/css" />
<style type="text/css" media="screen">

fieldset { width:200px;margin:30px auto;}

</style>
]]
title="Menu: Administrator Panel: WebDAV Server Timeout"
response:include"/rtl/.header.lsp"
?>
<h1>WebDAV Server Timeout</h1>

<fieldset>
<legend>WebDAV Session Timeout</legend> 
<form method="post">
<input name="timeout" value="<?lsp=davtmo?>"/>
<span class="lefthlp">
<a href="#"><img style="float:right;padding-right:20px" src="../../bindows/html/images/questionmark.16.gif" />
<span>

<h3>WebDAV session URL timeout in minutes</h3>

<b>The WebDAV server can be used in two modes:</b>

<p><b>Mode 1 (default):</b><br/>
WebDAV clients connecting to the server can use the login session from the Web-File-Manager. The benefit in using the browser's login session is that the WebDAV clients do not need to login and it becomes easier for the user to use the WebDAV server. Another benefit is that it is easy to logout, thus making it easier to protect your data. Logging out in the Web-File-Manager by pressing the logout button automatically invalidates the connection used by any WebDAV client using the same session. The WebDAV Timeout value is the number of minutes a WebDAV session is allowed to be inactive before automatically logging out the user.
</p>
<p><b>Mode 2:</b><br/>
Inheriting login sessions are disabled and all WebDAV clients connecting to the server must authenticate. Many WebDAV clients have a problem with authentication, thus your user(s) may experience problems logging in. Also, many WebDAV clients cannot be made to forget the password, thus forcing you to reboot the client computer in order to remove the password. In other words, connecting a WebDAV client from a public computer such as an Internet café is not safe. To disable mode 1 and enable mode 2, set the WebDAV Timeout to zero.
</p>
<p>Changing the timeout value requires that you restart the server for the change to take effect.</p>
</span>
</a>
</span>
<input type="submit" value="Save"/>
</form>
</fieldset>


<?lsp response:include".footer.lsp" ?>
