<?lsp

local enableDDNS = request:data"EnableDDNS"
if enableDDNS then
   if enableDDNS=="yes" then
      response:sendredirect"EnableDDNS.lsp"
   else
      response:sendredirect"../intro/"
   end
   return
end


local session=request:session(true)
title="The FuguHub DDNS Update Client"
headerdata=[[
<style type="text/css">
#fmttab table, #fmttab th, #fmttab td{border:1px solid gray;}
#fmttab th {
  background: #2F94FA;
  font-weight: bold;
  height:1.8em;
}
#fmttab td { width:50%;padding:5px; }
#SelectDiv { margin: auto;width:80%;padding:1em;}

#fmttab {border-radius: 10px;box-shadow: 10px 10px 5px #444;}
#continue { padding:10px;font-weight:bold;font-size:120%}
</style>
<script src="/rtl/jquery.js"></script>
<script src="../help.js"></script>
<script>
onload=function() {
   $("#continue").click(function() {
      var msg;
      if($("#yes").is(':checked')) {
         return true;
      }
      else {
         msg='Do not click "OK" unless you fully understand how to setup and manually configure DDNS.\n\nYou will exit the configuration wizard if you click "OK"';
      }
      return confirm(msg);
   });
   $("#howitworksbut").click(function() {$(this).hide();$("#howitworks").show();return false;});
   $("#howitworks").hide();

};


</script>
]]
response:include"../wizard/.header.lsp"
?>
<h1><?lsp=title?></h1>

<p>FuguHub has integrated support for the following DDNS service providers: <a href="http://dyndns.org" target="_blank">DynDNS</a>, <a href="http://no-ip.com" target="_blank">No-IP.com</a>, and <a href="http://zoneedit.com" target="_blank">ZoneEdit</a>.</p>

<p>You can also use other DDNS providers, but you will have to run an external DDNS update client to update your DDNS settings.</p>

<p>After pressing the continue button below, you must decide which of the supported service providers to use if you plan on using the integrated FuguHub DDNS update client.</p>


<h1>Suggestions</h1>
<div id="fmttab">
<table><tr>
<th>Personal use</th>
<th>Commercial use</th>
</tr>
<tr>
<td>
<p>If you do not have a registered domain name, select a free subdomain from No-IP.com or DynDNS. You can also register your own domain name via No-IP.com's paid service.</p>
<p>If you have a registered domain name, but do not want to pay for DDNS service, select ZoneEdit.</p>
</td>
<td>
<p>Commercial users should register a domain name.</p><p>The supported DDNS providers provide domain registering in addition to providing DDNS service. We suggest that you study the price and features for each of the supported DDNS provider by clicking on the above links.</p>
</td>
</tr></table>
</div>
<br/>
<h1>Enable DDNS</h1>
<div class="roundedbox bluebox" id="SelectDiv">
<p><b>Select one of the two following options and click "Continue". Click the first option if you are uncertain:</b></p>

<form method="post">
<ul>
<li>
<input id="yes" type="radio" name="EnableDDNS" value="yes" checked="checked" />
Enable and configure the integrated FuguHub DDNS client.
</li>
<li>
<input id="no" type="radio" name="EnableDDNS" value="no" />
I do not need the integrated FuguHub DDNS client because:
<ul>
<li>I have a static IP address and do not need to update DDNS.</li>
<li>I have multiple domain names and must therefore use a more advanced external DDNS client.</li>
<li>I plan on using the DDNS client integrated into my router.</li>
<li>I want to use a non supported DDNS service provider.</li>
</ul>
</li>
</ul>
<input id = "continue" type="submit" value="Continue" />
</form>
</div>

<br/><br/>
<a id="howitworksbut" href="#">Click here if you want to know how DDNS works</a>
<div id="howitworks">
<h1>How it works</h1>
<h3>(Optional information)</h3>

<p>External users can now access your computer remotely by using your WAN IP address.</p>

<p>Using the IP address to access your FuguHub server is cumbersome for two reasons: </p>
<ul>
<li>It is hard to remember the IP address.</li>
<li>Your IP address usually changes dynamically within 48 hours.</li>
</ul>

<h3>DNS</h3>
<p>We need to find a method for using names such as http://mycomputer.com
instead of http://<?lsp=session.wanIP and session.wanIP or "69.123.225.54"?>. This translation is normally handled by a Domain Name System (DNS) server and can be configured if you register a domain name and if you have a static WAN IP address. As an example, you can access the Google search engine by typing in http://www.google.com in a browser. The domain name google.com is registered to Google and made available on the Internet. The browser asks a DNS server for the IP address of the domain name. The DNS server translates the domain name to an IP address and gives this IP address to the browser.</p>

<p>We recommend using a DDNS service provider even if you have a static WAN IP address since it is difficult to setup and operate a DNS server.</p>

<h3>DDNS</h3>

<p>Dynamic DNS (DDNS) allows an Internet domain name to be assigned to a computer with a varying (dynamic) IP address. DDNS is handled by online DDNS service providers.</p>

<p>You do not need to understand how DDNS works, but if you are curious, you can read about how <a href="http://en.wikipedia.org/wiki/Ddns" target="_blank">Dynamic DNS</a> works at Wikipedia.</p>
 

<h3>DDNS service providers</h3>

<p>DDNS providers typically provide two types of DDNS services: a free service and a commercial service.</p>

<p>You can find many DDNS service providers on the Internet. Some are free and some require that you pay a monthly/yearly fee.</p> 
</div>

<?lsp
showAbort=true
response:include"../wizard/.footer.lsp"
?>
