<?lsp
headerdata=[[
<style>{color:blue;text-decoration:underline}</style>
]]
title="Menu: Mail Manager: Help"
response:include"/rtl/.header.lsp"
?>


<?lsp if not bd.list2tab(bd.db.roles.load().v).mailbatch then ?>

<h1>Batch Job Editor Disabled!</h1>

<p>The Batch Job Editor is by default disabled. To enable the Batch Job Editor, navigate to the Role Editor and create a new role with the role name: mailbatch. You can create the role by clicking the following <a target="_blank" href="../../admin/roles.lsp?role=mailbatch">link</a> and then click the save button. Navigate back to this page after you have clicked the save button and press the browser's refresh button. You should see a new menu entry "Batch Jobs" to the left. The menu entry takes you to the Batch Job Editor.</p>
<?lsp end ?>

<h1>Access Rights</h1>


<p>Users in the "mailbatch" role have access to the batch job list when sending emails and can attach a batch job to a mail job. The batch job list is shown in the Web File Manager when clicking the "Email" context menu link.	Note, the user using the Web File Manager must be in the mailbatch role to see the batch job list. In addition, at least one batch job must have been created.</p>
<p>Users that are in the "mailmanager" and "mailbatch" roles can also create batch jobs.</p>


<h1>Creating Batch Jobs</h1>

<p>Navigate to the Batch Job Editor and click Create New Job. Enter a job name and the path + name to an external command. The external command can be an executable or a script. The name must include the absolute path to the external command. For example, on Windows the path would typically start with c:\the-path\name.cmd.</p>

<h1>Batch Job Parameters</h1>

<p>The external batch job receives the following parameters from FuguHub:</p>
<ul>
<li>Parameter 1: The absolute path + name to the file requested by the contact.</li>
<li>Parameter 2: The contact's email address.</li>
<li>Parameter 3: The optional [ID] string, if set using the Contact Editor.</li>
</ul>
<p>The ID string is typically set to the customer's product ID and or name. The ID is opaque to FuguHub and can be any valid string. The ID string, if set, is double quoted by the server to make sure the string is sent as one argument to the external batch command.</p>

<h1>The Batch Job Return Parameter</h1>

<p>The return parameter must be printed to standard out. The parameter can be any of the following:</p>

<ul>
<li>Empty string: Signals success to the server.  The server uses the original file name when opening and sending the file to the contact.</li>
<li>Absolute path+name: The batch job can instruct the server to use another file for the contact than the original file. </li>
<li>Error message: A non empty string not evaluating to an "absolute path + name" is regarded as an error message.</li>
</ul>

<p>Since the external batch command can request the server to use an alternate file than the original file sent using the Web File Manager, the file sent using the Web File Manager may have no purpose other than giving the external batch command information about what command to run. For example, an external batch command can be designed such that the command takes another script as argument -- i.e. the file sent using the Web File Manager can be a script to run.</p>

<?lsp response:include".footer.lsp" ?>
